// Goodies.   Command driven interface to the halflife engine, providing
// more access to do neat things from the command line or external programs.
//

#include <stdio.h>
#include <errno.h>
#include <stdlib.h>
#include <sys/socket.h>
#include <sys/un.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <fcntl.h>
#include <extdll.h>
#include <meta_api.h>		// of course

#include "goodies.h"

#define MAXENTS 64

int fsock=-1, clisock=-1;
extern edict_t *clients[32];
char clsay[32][280];

struct sockaddr_un fsockname;
unsigned int fsocknamesize;
char fname[64];
int clierr=0;

int stripcmd=1;
int elimdup=0;
float reportdelay=0.3;

 float check_server_cmd = 0.0;
 float previous_time = -1.0;
 float info_time=0.0;

typedef struct ourent_s {
edict_t *ent;
char name[64];
int behave;
int touch;
int state;
edict_t *target;
edict_t *lasttarget;
float life;
float lastthink;
Activity activity;
} ourent_t;

ourent_t *ourent[MAXENTS];
int numents=0;

cvar_t sv_goodies = {"goodies",""};

char inpbuff[2048];
float infotime=0;
edict_t *listenserver_edict = NULL;

#define NOTENOUGHARGS(msg) {char errbuff[256];snprintf(errbuff, sizeof(errbuff), "Not enough arguments to entity: %s", (msg));msgout(errbuff);return(0);}

int ProcessCommand (char *cmdline)
{
char buff[128];
         char gcmd[30], opts[512];
         char *p;
         int a;

if ((p=(char *)strchr(cmdline, '\n'))!=NULL)
   *p=0;
         
         if (((p=(char *)strchr(cmdline, ' '))!=NULL)&&((a=p-cmdline)<30))
           {
           strncpy(opts, p+1, 512);
           opts[512]=0;
           strncpy(gcmd, cmdline, a);
           gcmd[a]=0;
//         UTIL_LogPrintf("Command read: %s (%s)\n", gcmd, opts);
          }
        else
          strncpy(gcmd, cmdline, sizeof(gcmd)-1);
        
          if (strcasecmp(gcmd, "sac")==0)
             {
             strcat(opts, "\n");
             UTIL_ClientPrintAll(HUD_PRINTCENTER, opts);
             return(1);
             }
          else
           if (strcasecmp(gcmd, "listents")==0)
             {
              char buff[128];
             for (a=0;a<numents;a++)
              {
              snprintf(buff, sizeof(buff)-1, "Ent: %s / %d / %f", ourent[a]->name, ourent[a]->behave, ourent[a]->life);
              msgout(buff);
              }
             return(1);
             }
            else
           if (strcasecmp(gcmd, "set")==0)
            {
            int u=atoi(opts), v1;
            char vn[16];
            edict_t *targ;
            int add;
            char val[256];
            char *q;
 
            if ( ((p=(char *)strchr(opts, ' '))==NULL)||(*p=0)||(a<1)||((q=(char *)strchr(++p, ' '))==NULL)||((unsigned int)(q-p)>sizeof(vn)) )
              {
              sprintf(buff, "set <uid> <name> <value>");
              msgout(buff);
              return(0);
              }
              
            strncpy(vn, p, q-p);
            vn[q-p]=0;
            
            if (q[1]=='+') 
              {
              add=1;
              strncpy(val, q+2, sizeof(val)-1);
              }
            else
              {
              add=0;
              strncpy(val, q+1, sizeof(val)-1);
              }

while ((p=strchr(val, ' '))!=NULL)
  *p=',';

             targ=NULL;
if (!u)
{
for (v1=numents-1;v1>=0;v1--)
 if (strcmp(ourent[v1]->name, opts)==0)
  {
  targ=ourent[v1]->ent;
  break;
  }
}
else
  targ=FindPlayerByUID(u);
  
            if (targ==NULL)
              {
              sprintf(buff, "Unable to find entity or uid: %d (%s)", u, opts);
              msgout(buff);
              return(0);
              }

if (!u)
 SetEnt(targ, vn, val, add, opts);
else
 {
 snprintf(buff, sizeof(buff)-1, "%s<%d>", STRING(targ->v.netname), u);
 SetEnt(targ,vn,val,add,buff);
 }
           
          return(0);
            }
          else
           if (strcasecmp(gcmd, "spawnitem")==0)
            {
        edict_t *pent;
int istr;
char *q;
int v1=0,v2=0,v3=0, drop=0, limit=0, behave=0, touch=0;
float scale=0;
float life=0;
char model[256];
char set[256];

if (numents==MAXENTS-1)
  {
  msgout("Too many entities in play");
  return(0);
  }

if ((p=strchr(opts, ' '))==NULL)
  {
             msgout("usage: spawnitem <name> <model> <coords> [options]");
              return(0);
  }
  *p=0;
   p++;

model[0]=set[0]=0;

if ((q=strchr(p, ' '))!=NULL)
   {
   *q=0;
   strncpy(model, p, sizeof(model)-1);
   p=q+1;
   }
 
 v1=atoi(p);
 if ((q=strchr(p, ' '))!=NULL)
  {
  p=q+1;
  v2=atoi(q);
  if ((q=strchr(p, ' '))!=NULL)
   {
   p=q+1;
   v3=atoi(q);
   }
  }  

while ((q!=NULL)&&(p[0]))
  {
  if (strncasecmp(p, "drop", 4)==0)
     drop=1;
else
  if (strncasecmp(p, "scale=", 6)==0)
     scale=atof(p+6);
else
  if (strncasecmp(p, "limit=", 6)==0)
     limit=atoi(p+6);
else
  if (strncasecmp(p, "behave=", 7)==0)
     behave=atoi(p+7);
else
  if (strncasecmp(p, "touch=", 6)==0)
     touch=atoi(p+6);
else
  if (strncasecmp(p, "life=", 5)==0)
     life=atof(p+5);
else
  if (strncasecmp(p, "set", 3)==0)
    {
    strncpy(set, p+4, sizeof(set)-1);
    break;
    }

  if ((q=strchr(p, ' '))!=NULL)
   p=q+1;

  }

if (limit)
   {
   int a, b=0;
   for (a=0;a<numents;a++)
     if (strcmp(ourent[a]->name, opts)==0)
       b++;
   
   if (b>=limit)
     return(1); // return silently
   }
        
        istr = MAKE_STRING("item_health");
        pent = CREATE_NAMED_ENTITY(istr);
                 
        if ( pent == NULL )
        {
char errmsg[256];
snprintf(errmsg, sizeof(errmsg)-1, "Unable to create entity: %s", opts);
msgout(errmsg);
return(0);
        }
        pent->v.origin = Vector(v1,v2,v3);
        pent->v.spawnflags |= SF_NORESPAWN;
        pent->v.solid=1;
        pent->v.nextthink = gpGlobals->time + 0.1;
        SET_MODEL(pent, model);
if (scale)
        pent->v.scale=scale;
if (drop)
        DROP_TO_FLOOR(pent);
if (set[0])
   {
   char *r;
   char vn[16];
   int add;

   p = q = (char *)set;
   
   while ((q!=NULL)&&(p[0]))
 {
    
  if ((q=strchr(p, ' '))!=NULL)
   *q=0;

  if ( ((r=strchr(p, '='))!=NULL)&&((unsigned int)(r-p)<sizeof(vn)) )
   {
   strncpy(vn, p, r-p);
   vn[r-p]=0;
   r++;
   if (r[0]=='+')
     {
     add=1;
     r++;
     }
   else
     add=0;

   strncpy(buff, r, sizeof(buff)-1);
   SetEnt(pent, vn, buff, add, opts);
   }
  else
   {
   snprintf(buff, sizeof(buff)-1, "usage: set variable=value (wrong or variable too long: %s)", p);
   msgout(buff);
   }
   
  if (q)
    p=q+1;
 }
}
        ourent[numents]=(ourent_t *)malloc(sizeof(ourent_t));
        ourent[numents]->ent=pent;
        ourent[numents]->behave=behave;
        ourent[numents]->state=0;
        ourent[numents]->target=NULL;
        ourent[numents]->life=life;
        ourent[numents]->touch=touch;
        ourent[numents]->lastthink=gpGlobals->time;
        strncpy(ourent[numents]->name, opts, sizeof(ourent[numents]->name));
        numents++;
        snprintf(buff, sizeof(buff), "Spawned \"%s\" at %d,%d,%d\n", opts,v1,v2,v3);
        msgout(buff);
        return(1);
        }
      else
           if (strcasecmp(gcmd, "playatuid")==0)
            {
            int u=atoi(opts);
            edict_t *targ;
            
            if (((p=strchr(opts, ' '))==NULL)||(a<1))
              {
              sprintf(buff, "playatuid <uid> <sound>");
              msgout(buff);
              return(0);
              }
            
            if ((targ=FindPlayerByUID(u))==NULL)
              {
              sprintf(buff, "Unable to find uid %d", u);
              msgout(buff);
              return(0);
              }
            UTIL_LogPrintf("Playing sound \"%s\" at \"%s<%i>\"\n", p+1, STRING( targ->v.netname ), u);
            (*g_engfuncs.pfnEmitSound)( targ, 0, p+1, 1.0, ATTN_NORM, 0, PITCH_NORM);
            return(1);            
            }
          else
           if (strcasecmp(gcmd, "playat")==0)
            {
            edict_t *targ;
           char args[25][64];
           int argc=0;
            char *p, *q;
          
           q=(char *)opts;
           
while ((p=(char *)strtok(q, " "))!=NULL)
 {
 strncpy(args[argc], p,sizeof(args[argc])); 
 argc++;q=NULL;
 }
            
            if (argc<9)
              {
              sprintf(buff, "playat requires 9 arguments.");
              msgout(buff);
              return(0);
              }
            
            if ((targ=FindPlayerByUID(atoi(args[0])))==NULL)
              {
              sprintf(buff, "Unable to find uid %d", atoi(args[0]));
              msgout(buff);
              return(0);
              }
//            UTIL_LogPrintf("Playing sound \"%s\" at \"%s<%i>\"\n", p+1, STRING( targ->v.netname ), u);
 UTIL_EmitAmbientSound(targ, Vector( atoi(args[1]),atoi(args[2]),atoi(args[3]) ), args[4], atof(args[5]), atof(args[6]), atoi(args[7]), atoi(args[8]));
 
//            (*g_engfuncs.pfnEmitSound)( targ, 0, p+1, 1.0, ATTN_NORM, 0, PITCH_NORM);
            return(1);            
            }
         else
          if (strcasecmp(gcmd, "saytext")==0)
            {
            int c=atoi(opts);
            
            if (((p=strchr(opts, ' '))==NULL)||(c<1))
              {
              msgout("saytext <color set> <text>");
              return(0);
              }
            
            UTIL_FakeMsg(c, p+1);
            UTIL_LogPrintf("\"Console:\" %s\n", p+1);
            return(1);
            }
         else
          if (strcasecmp(gcmd, "saytextone")==0)
            {
            int u=atoi(opts), c;
            edict_t *targ;
            char *q;
            
            if ( ((p=strchr(opts, ' '))==NULL)||((c=atoi(p+1))<1)||((q=strchr(p+1, ' '))==NULL)||((targ=FindPlayerByUID(u))==NULL) )
              {
              msgout("saytextone <player uid> <color set> <text>");
              return(0);
              }
            
            UTIL_FakeMsgOne(c, q+1, targ);
if (q[1]!='.')
{
            snprintf(buff, sizeof(buff)-1, "saytextone \"%s<%d>\"%s", STRING(targ->v.netname), \
                            GETPLAYERUSERID( targ ), q+1);
            msgout(buff);
}
            return(1);
            }
else
       if (strcasecmp(gcmd, "sayhudall")==0)
           {
           char parmstring[256];

            if (((p=(char *)strchr(opts, ' '))==NULL)||((unsigned int)(a=p-opts)>sizeof(parmstring)-1))
              {
              msgout("sayhudall <options> <text>");
              return(0);
              }
       strncpy(parmstring, opts, a);
       parmstring[a]=0;
          
       hudtextparms_t tp;
       MakeHudParms(parmstring, tp);
       UTIL_HudMessageAll (tp, p+1);
       UTIL_LogPrintf("\"HudAll:\" %s\n", p+1);       
       return(1);
          }
            else
       if (strcasecmp(gcmd, "tempent")==0)
          {
           char teargs[25][64];
           int teargc=0, effect;
            char *p, *q;
            int a,b,c;
           edict_t *e, *f;
           short sprite, sprite2;
          
           q=(char *)opts;
           
if ((p=(char *)strtok(q, " "))==NULL)
  {
  msgout("tempent <effect> <options>");
  return(0);
  }

effect=atoi(p);

while ((p=(char *)strtok(NULL, " "))!=NULL)
 {
 strncpy(teargs[teargc], p,sizeof(teargs[teargc])); 
 teargc++;
 }

switch (effect)
   {
  case 0: // te_beampoints
     if (teargc<17)
        NOTENOUGHARGS("te_beampoints (17)");
        
sprite=PRECACHE_MODEL(teargs[6]);

     a=atoi(teargs[0]);
     b=atoi(teargs[1]);
     c=atoi(teargs[2]);
    
     MESSAGE_BEGIN(MSG_PAS, SVC_TEMPENTITY, Vector(a,b,c));
       WRITE_BYTE(effect);
       WRITE_COORD(a);
       WRITE_COORD(b);
       WRITE_COORD(c);
       
       WRITE_COORD(atoi(teargs[3]));
       WRITE_COORD(atoi(teargs[4]));
       WRITE_COORD(atoi(teargs[5]));
       
       WRITE_SHORT(sprite);
       WRITE_BYTE(atoi(teargs[7]));
       WRITE_BYTE(atoi(teargs[8]));
       WRITE_BYTE(atoi(teargs[9]));
       WRITE_BYTE(atoi(teargs[10]));
       WRITE_BYTE(atoi(teargs[11]));
       WRITE_BYTE(atoi(teargs[12]));
       WRITE_BYTE(atoi(teargs[13]));
       WRITE_BYTE(atoi(teargs[14]));
       WRITE_BYTE(atoi(teargs[15]));
       WRITE_BYTE(atoi(teargs[16]));
     MESSAGE_END();
     break;
  case 1: //TE_BEAMENTPOINT
     if (teargc<15)
        NOTENOUGHARGS("te_beamentpoint (15)");

            if ((e=FindPlayerByUID(atoi(teargs[0])))==NULL)
              {
              sprintf(buff, "te_beamentpoint: Unable to find uid %d", atoi(teargs[0]));
              msgout(buff);
              return(0);
              }

sprite=PRECACHE_MODEL(teargs[4]);
     
     MESSAGE_BEGIN(MSG_PAS, SVC_TEMPENTITY, e->v.origin);
       WRITE_BYTE(effect);
       WRITE_SHORT(ENTINDEX(e));

       WRITE_COORD(atoi(teargs[1]));
       WRITE_COORD(atoi(teargs[2]));
       WRITE_COORD(atoi(teargs[3]));

       WRITE_SHORT(sprite);
       WRITE_BYTE(atoi(teargs[5]));
       WRITE_BYTE(atoi(teargs[6]));
       WRITE_BYTE(atoi(teargs[7]));
       WRITE_BYTE(atoi(teargs[8]));
       WRITE_BYTE(atoi(teargs[9]));
       WRITE_BYTE(atoi(teargs[10]));
       WRITE_BYTE(atoi(teargs[11]));
       WRITE_BYTE(atoi(teargs[12]));
       WRITE_BYTE(atoi(teargs[13]));
       WRITE_BYTE(atoi(teargs[14]));
     MESSAGE_END();
     break;
  case 2: // gunshot
     if (teargc<3)
        NOTENOUGHARGS("te_gunshot (3)");

     a=atoi(teargs[0]);
     b=atoi(teargs[1]);
     c=atoi(teargs[2]);
    
     MESSAGE_BEGIN(MSG_PAS, SVC_TEMPENTITY, Vector(a,b,c));
       WRITE_BYTE(effect);
       WRITE_COORD(a);
       WRITE_COORD(b);
       WRITE_COORD(c);
    MESSAGE_END();
    break;
  case 3: // te_explosion
     if (teargc<7)
        NOTENOUGHARGS("te_explosion (7)");
        
sprite=PRECACHE_MODEL(teargs[3]);

     a=atoi(teargs[0]);
     b=atoi(teargs[1]);
     c=atoi(teargs[2]);
    
     MESSAGE_BEGIN(MSG_PAS, SVC_TEMPENTITY, Vector(a,b,c));
       WRITE_BYTE(effect);
       WRITE_COORD(a);
       WRITE_COORD(b);
       WRITE_COORD(c);
       
       WRITE_SHORT(sprite);
       
       WRITE_BYTE(atoi(teargs[4]));
       WRITE_BYTE(atoi(teargs[5]));
       WRITE_BYTE(atoi(teargs[6]));
     MESSAGE_END();
     break;
  case 4: // tarexplosion
     if (teargc<3)
        NOTENOUGHARGS("te_tarexplosion (3)");

     a=atoi(teargs[0]);
     b=atoi(teargs[1]);
     c=atoi(teargs[2]);
    
     MESSAGE_BEGIN(MSG_PAS, SVC_TEMPENTITY, Vector(a,b,c));
       WRITE_BYTE(effect);
       WRITE_COORD(a);
       WRITE_COORD(b);
       WRITE_COORD(c);
    MESSAGE_END();
    break;
  case 5: // te_smoke
     if (teargc<6)
        NOTENOUGHARGS("te_smoke (6)");

sprite=PRECACHE_MODEL(teargs[3]);

     a=atoi(teargs[0]);
     b=atoi(teargs[1]);
     c=atoi(teargs[2]);
    
     MESSAGE_BEGIN(MSG_PAS, SVC_TEMPENTITY, Vector(a,b,c));
       WRITE_BYTE(effect);
       WRITE_COORD(a);
       WRITE_COORD(b);
       WRITE_COORD(c);
       
       WRITE_SHORT(sprite);
       WRITE_BYTE(atoi(teargs[4]));
       WRITE_BYTE(atoi(teargs[5]));
    MESSAGE_END();
    break;
  case 6: // te_tracer
     if (teargc<6)
        NOTENOUGHARGS("te_tracer (6)");
        
     a=atoi(teargs[0]);
     b=atoi(teargs[1]);
     c=atoi(teargs[2]);
    
     MESSAGE_BEGIN(MSG_PAS, SVC_TEMPENTITY, Vector(a,b,c));
       WRITE_BYTE(effect);
       WRITE_COORD(a);
       WRITE_COORD(b);
       WRITE_COORD(c);
       
       WRITE_COORD(atoi(teargs[3]));
       WRITE_COORD(atoi(teargs[4]));
       WRITE_COORD(atoi(teargs[5]));
     MESSAGE_END();
     break;
  case 7: // te_lightning
     if (teargc<9)
        NOTENOUGHARGS("te_lightning (9)");
        
     a=atoi(teargs[0]);
     b=atoi(teargs[1]);
     c=atoi(teargs[2]);

sprite=PRECACHE_MODEL(teargs[9]);
    
     MESSAGE_BEGIN(MSG_PAS, SVC_TEMPENTITY, Vector(a,b,c));
       WRITE_BYTE(effect);
       WRITE_COORD(a);
       WRITE_COORD(b);
       WRITE_COORD(c);
       WRITE_COORD(atoi(teargs[3]));
       WRITE_COORD(atoi(teargs[4]));
       WRITE_COORD(atoi(teargs[5]));

       WRITE_BYTE(atoi(teargs[6]));
       WRITE_BYTE(atoi(teargs[7]));
       WRITE_BYTE(atoi(teargs[8]));
       WRITE_SHORT(sprite);
     MESSAGE_END();
     break;
   case 8: //TE_BEAMENTS
     if (teargc<13)
        NOTENOUGHARGS("te_beaments (13)");

            if ((e=FindPlayerByUID(atoi(teargs[0])))==NULL)
              {
              sprintf(buff, "te_beaments: Unable to find uid %d", atoi(teargs[0]));
              msgout(buff);
              return(0);
              }

            if ((f=FindPlayerByUID(atoi(teargs[1])))==NULL)
              {
              sprintf(buff, "te_beaments: Unable to find uid %d", atoi(teargs[1]));
              msgout(buff);
              return(0);
              }

sprite=PRECACHE_MODEL(teargs[2]);
     
     MESSAGE_BEGIN(MSG_PAS, SVC_TEMPENTITY, e->v.origin);
       WRITE_BYTE(effect);
       WRITE_SHORT(ENTINDEX(e));
       WRITE_SHORT(ENTINDEX(f));

       WRITE_SHORT(sprite);
       WRITE_BYTE(atoi(teargs[3]));
       WRITE_BYTE(atoi(teargs[4]));
       WRITE_BYTE(atoi(teargs[5]));
       WRITE_BYTE(atoi(teargs[6]));
       WRITE_BYTE(atoi(teargs[7]));
       WRITE_BYTE(atoi(teargs[8]));
       WRITE_BYTE(atoi(teargs[9]));
       WRITE_BYTE(atoi(teargs[10]));
       WRITE_BYTE(atoi(teargs[11]));
       WRITE_BYTE(atoi(teargs[12]));
     MESSAGE_END();
     break;
  case 9: // te_sparks
     if (teargc<3)
        NOTENOUGHARGS("te_sparks (3)");

     a=atoi(teargs[0]);
     b=atoi(teargs[1]);
     c=atoi(teargs[2]);
    
     MESSAGE_BEGIN(MSG_PAS, SVC_TEMPENTITY, Vector(a,b,c));
       WRITE_BYTE(effect);
       WRITE_COORD(a);
       WRITE_COORD(b);
       WRITE_COORD(c);
    MESSAGE_END();
    break;
 case 10: // te_lavasplash
     if (teargc<3)
        NOTENOUGHARGS("te_lavasplash (3)");

     a=atoi(teargs[0]);
     b=atoi(teargs[1]);
     c=atoi(teargs[2]);
    
     MESSAGE_BEGIN(MSG_PAS, SVC_TEMPENTITY, Vector(a,b,c));
       WRITE_BYTE(effect);
       WRITE_COORD(a);
       WRITE_COORD(b);
       WRITE_COORD(c);
    MESSAGE_END();
    break;
 case 11: // te_teleport
     if (teargc<3)
        NOTENOUGHARGS("te_teleport (3)");

     a=atoi(teargs[0]);
     b=atoi(teargs[1]);
     c=atoi(teargs[2]);
    
     MESSAGE_BEGIN(MSG_PAS, SVC_TEMPENTITY, Vector(a,b,c));
       WRITE_BYTE(effect);
       WRITE_COORD(a);
       WRITE_COORD(b);
       WRITE_COORD(c);
    MESSAGE_END();
    break;
 case 12: // te_explosion2
     if (teargc<5)
        NOTENOUGHARGS("te_explosion2 (5)");

     a=atoi(teargs[0]);
     b=atoi(teargs[1]);
     c=atoi(teargs[2]);
    
     MESSAGE_BEGIN(MSG_PAS, SVC_TEMPENTITY, Vector(a,b,c));
       WRITE_BYTE(effect);
       WRITE_COORD(a);
       WRITE_COORD(b);
       WRITE_COORD(c);
       WRITE_BYTE(atoi(teargs[3]));
       WRITE_BYTE(atoi(teargs[4]));
    MESSAGE_END();
    break;
 case 14: // te_implosion
     if (teargc<6)
        NOTENOUGHARGS("te_implosion (6)");

     a=atoi(teargs[0]);
     b=atoi(teargs[1]);
     c=atoi(teargs[2]);
    
     MESSAGE_BEGIN(MSG_PAS, SVC_TEMPENTITY, Vector(a,b,c));
       WRITE_BYTE(effect);
       WRITE_COORD(a);
       WRITE_COORD(b);
       WRITE_COORD(c);
       WRITE_BYTE(atoi(teargs[3]));
       WRITE_BYTE(atoi(teargs[4]));
       WRITE_BYTE(atoi(teargs[5]));
    MESSAGE_END();
    break;
  case 15: // te_spritetrail
     if (teargc<12)
        NOTENOUGHARGS("te_spritetrail (12)");
        
     a=atoi(teargs[0]);
     b=atoi(teargs[1]);
     c=atoi(teargs[2]);

sprite=PRECACHE_MODEL(teargs[6]);
    
     MESSAGE_BEGIN(MSG_PAS, SVC_TEMPENTITY, Vector(a,b,c));
       WRITE_BYTE(effect);
       WRITE_COORD(a);
       WRITE_COORD(b);
       WRITE_COORD(c);
       WRITE_COORD(atoi(teargs[3]));
       WRITE_COORD(atoi(teargs[4]));
       WRITE_COORD(atoi(teargs[5]));

       WRITE_SHORT(sprite);

       WRITE_BYTE(atoi(teargs[7]));
       WRITE_BYTE(atoi(teargs[8]));
       WRITE_BYTE(atoi(teargs[9]));
       WRITE_BYTE(atoi(teargs[10]));
       WRITE_BYTE(atoi(teargs[11]));
     MESSAGE_END();
     break;
  case 17: // te_sprite
     if (teargc<6)
        NOTENOUGHARGS("te_sprite (6)");
        
     a=atoi(teargs[0]);
     b=atoi(teargs[1]);
     c=atoi(teargs[2]);

sprite=PRECACHE_MODEL(teargs[3]);
    
     MESSAGE_BEGIN(MSG_PAS, SVC_TEMPENTITY, Vector(a,b,c));
       WRITE_BYTE(effect);
       WRITE_COORD(a);
       WRITE_COORD(b);
       WRITE_COORD(c);

       WRITE_SHORT(sprite);
       WRITE_BYTE(atoi(teargs[4]));
       WRITE_BYTE(atoi(teargs[5]));
     MESSAGE_END();
     break;
  case 18: // beamsprite
     if (teargc<8)
        NOTENOUGHARGS("te_beamsprite (8)");
        
     a=atoi(teargs[0]);
     b=atoi(teargs[1]);
     c=atoi(teargs[2]);

sprite=PRECACHE_MODEL(teargs[6]);
sprite2=PRECACHE_MODEL(teargs[7]);
    
     MESSAGE_BEGIN(MSG_PAS, SVC_TEMPENTITY, Vector(a,b,c));
       WRITE_BYTE(effect);
       WRITE_COORD(a);
       WRITE_COORD(b);
       WRITE_COORD(c);
       WRITE_COORD(atoi(teargs[3]));
       WRITE_COORD(atoi(teargs[4]));
       WRITE_COORD(atoi(teargs[5]));

       WRITE_SHORT(sprite);
       WRITE_SHORT(sprite2);
     MESSAGE_END();
     break;
  case 22: //TE_BEAMFOLLOW
     if (teargc<8)
        NOTENOUGHARGS("te_beamfollow (8)");

            if ((e=FindPlayerByUID(atoi(teargs[0])))==NULL)
              {
              sprintf(buff, "te_beamfollow: Unable to find uid %d", atoi(teargs[0]));
              msgout(buff);
              return(0);
              }

sprite=PRECACHE_MODEL(teargs[1]);

     MESSAGE_BEGIN(MSG_PAS, SVC_TEMPENTITY, e->v.origin);
       WRITE_BYTE(effect);
       WRITE_SHORT(ENTINDEX(e));
       WRITE_SHORT(sprite);

       WRITE_BYTE(atoi(teargs[2]));
       WRITE_BYTE(atoi(teargs[3]));
       WRITE_BYTE(atoi(teargs[4]));
       WRITE_BYTE(atoi(teargs[5]));
       WRITE_BYTE(atoi(teargs[6]));
       WRITE_BYTE(atoi(teargs[7]));
     MESSAGE_END();
     break;
  case 23: // te_glowsprite
     if (teargc<7)
        NOTENOUGHARGS("te_glowsprite (7)");
        
     a=atoi(teargs[0]);
     b=atoi(teargs[1]);
     c=atoi(teargs[2]);

sprite=PRECACHE_MODEL(teargs[3]);
    
     MESSAGE_BEGIN(MSG_PAS, SVC_TEMPENTITY, Vector(a,b,c));
       WRITE_BYTE(effect);
       WRITE_COORD(a);
       WRITE_COORD(b);
       WRITE_COORD(c);

       WRITE_SHORT(sprite);
       WRITE_BYTE(atoi(teargs[4]));
       WRITE_BYTE(atoi(teargs[5]));
       WRITE_BYTE(atoi(teargs[6]));
     MESSAGE_END();
     break;
   case 24: //TE_BEAMRING
     if (teargc<13)
        NOTENOUGHARGS("te_beamring (13)");

            if ((e=FindPlayerByUID(atoi(teargs[0])))==NULL)
              {
              sprintf(buff, "te_beamring: Unable to find uid %d", atoi(teargs[0]));
              msgout(buff);
              return(0);
              }

            if ((f=FindPlayerByUID(atoi(teargs[1])))==NULL)
              {
              sprintf(buff, "te_beamring: Unable to find uid %d", atoi(teargs[1]));
              msgout(buff);
              return(0);
              }

sprite=PRECACHE_MODEL(teargs[2]);
     
     MESSAGE_BEGIN(MSG_PAS, SVC_TEMPENTITY, e->v.origin);
       WRITE_BYTE(effect);
       WRITE_SHORT(ENTINDEX(e));
       WRITE_SHORT(ENTINDEX(f));
       WRITE_SHORT(sprite);

       WRITE_BYTE(atoi(teargs[3]));
       WRITE_BYTE(atoi(teargs[4]));
       WRITE_BYTE(atoi(teargs[5]));
       WRITE_BYTE(atoi(teargs[6]));
       WRITE_BYTE(atoi(teargs[7]));

       WRITE_BYTE(atoi(teargs[8]));
       WRITE_BYTE(atoi(teargs[9]));
       WRITE_BYTE(atoi(teargs[10]));

       WRITE_BYTE(atoi(teargs[11]));
       WRITE_BYTE(atoi(teargs[12]));
     MESSAGE_END();
     break;
  case 25: //te_streak_splash (tracers)
     if (teargc<10)
        NOTENOUGHARGS("te_streak_splash (10)");
        
     a=atoi(teargs[0]);
     b=atoi(teargs[1]);
     c=atoi(teargs[2]);

     MESSAGE_BEGIN(MSG_PAS, SVC_TEMPENTITY, Vector(a,b,c));
       WRITE_BYTE(effect);
       WRITE_COORD(a);
       WRITE_COORD(b);
       WRITE_COORD(c);
       WRITE_COORD(atoi(teargs[3]));
       WRITE_COORD(atoi(teargs[4]));
       WRITE_COORD(atoi(teargs[5]));


       WRITE_BYTE(atoi(teargs[6]));
       WRITE_SHORT(atoi(teargs[7]));
       WRITE_SHORT(atoi(teargs[8]));
       WRITE_SHORT(atoi(teargs[9]));
     MESSAGE_END();
     break;
  case 27: //te_dlight
     if (teargc<9)
        NOTENOUGHARGS("te_dlight (9)");
        
     a=atoi(teargs[0]);
     b=atoi(teargs[1]);
     c=atoi(teargs[2]);

     MESSAGE_BEGIN(MSG_PAS, SVC_TEMPENTITY, Vector(a,b,c));
       WRITE_BYTE(effect);
       WRITE_COORD(a);
       WRITE_COORD(b);
       WRITE_COORD(c);

       WRITE_BYTE(atoi(teargs[3]));
       WRITE_BYTE(atoi(teargs[4]));
       WRITE_BYTE(atoi(teargs[5]));
       WRITE_BYTE(atoi(teargs[6]));
       WRITE_BYTE(atoi(teargs[7]));
       WRITE_BYTE(atoi(teargs[8]));
     MESSAGE_END();
     break;
  case 28: //TE_ELIGHT
     if (teargc<10)
        NOTENOUGHARGS("te_elight (10)");

            if ((e=FindPlayerByUID(atoi(teargs[0])))==NULL)
              {
              sprintf(buff, "te_elight: Unable to find uid %d", atoi(teargs[0]));
              msgout(buff);
              return(0);
              }

     MESSAGE_BEGIN(MSG_PAS, SVC_TEMPENTITY, e->v.origin);
       WRITE_BYTE(effect); 
       WRITE_SHORT(ENTINDEX(e));
       WRITE_COORD(atoi(teargs[1]));
       WRITE_COORD(atoi(teargs[2]));
       WRITE_COORD(atoi(teargs[3]));

       WRITE_COORD(atoi(teargs[4]));
       WRITE_BYTE(atoi(teargs[5]));
       WRITE_BYTE(atoi(teargs[6]));
       WRITE_BYTE(atoi(teargs[7]));
       WRITE_BYTE(atoi(teargs[8]));
       WRITE_COORD(atoi(teargs[9]));
     MESSAGE_END();
     break;
  case 99: //TE_killbeam
     if (teargc<1)
        NOTENOUGHARGS("te_killbeam (1)");

            if ((e=FindPlayerByUID(atoi(teargs[0])))==NULL)
              {
              sprintf(buff, "te_killbeam: Unable to find uid %d", atoi(teargs[0]));
              msgout(buff);
              return(0);
              }

     MESSAGE_BEGIN(MSG_PAS, SVC_TEMPENTITY, e->v.origin);
       WRITE_BYTE(effect); 
       WRITE_SHORT(ENTINDEX(e));
     MESSAGE_END();
     break;
  case 100: // te_largefunnel
     if (teargc<5)
        NOTENOUGHARGS("te_largefunnel (5)");
        
     a=atoi(teargs[0]);
     b=atoi(teargs[1]);
     c=atoi(teargs[2]);

sprite=PRECACHE_MODEL(teargs[3]);
    
     MESSAGE_BEGIN(MSG_PAS, SVC_TEMPENTITY, Vector(a,b,c));
       WRITE_BYTE(effect);
       WRITE_COORD(a);
       WRITE_COORD(b);
       WRITE_COORD(c);

       WRITE_SHORT(sprite);
       WRITE_SHORT(atoi(teargs[4]));
     MESSAGE_END();
     break;
  case 101: //te_bloodstream
     if (teargc<8)
        NOTENOUGHARGS("te_bloodstream (8)");
        
     a=atoi(teargs[0]);
     b=atoi(teargs[1]);
     c=atoi(teargs[2]);

     MESSAGE_BEGIN(MSG_PAS, SVC_TEMPENTITY, Vector(a,b,c));
       WRITE_BYTE(effect);
       WRITE_COORD(a);
       WRITE_COORD(b);
       WRITE_COORD(c);
       WRITE_COORD(atoi(teargs[3]));
       WRITE_COORD(atoi(teargs[4]));
       WRITE_COORD(atoi(teargs[5]));

       WRITE_BYTE(atoi(teargs[6]));
       WRITE_BYTE(atoi(teargs[7]));
     MESSAGE_END();
     break;
  case 102: //te_showline
     if (teargc<6)
        NOTENOUGHARGS("te_showline (6)");
        
     a=atoi(teargs[0]);
     b=atoi(teargs[1]);
     c=atoi(teargs[2]);

     MESSAGE_BEGIN(MSG_PAS, SVC_TEMPENTITY, Vector(a,b,c));
       WRITE_BYTE(effect);
       WRITE_COORD(a);
       WRITE_COORD(b);
       WRITE_COORD(c);
       WRITE_COORD(atoi(teargs[3]));
       WRITE_COORD(atoi(teargs[4]));
       WRITE_COORD(atoi(teargs[5]));
     MESSAGE_END();
     break;
  case 103: //te_blood
     if (teargc<8)
        NOTENOUGHARGS("te_blood (8)");
        
     a=atoi(teargs[0]);
     b=atoi(teargs[1]);
     c=atoi(teargs[2]);

     MESSAGE_BEGIN(MSG_PAS, SVC_TEMPENTITY, Vector(a,b,c));
       WRITE_BYTE(effect);
       WRITE_COORD(a);
       WRITE_COORD(b);
       WRITE_COORD(c);
       WRITE_COORD(atoi(teargs[3]));
       WRITE_COORD(atoi(teargs[4]));
       WRITE_COORD(atoi(teargs[5]));

       WRITE_BYTE(atoi(teargs[6]));
       WRITE_BYTE(atoi(teargs[7]));
     MESSAGE_END();
     break;
  case 105: //TE_FIZZ
     if (teargc<3)
        NOTENOUGHARGS("te_fizz (3)");

            if ((e=FindPlayerByUID(atoi(teargs[0])))==NULL)
              {
              sprintf(buff, "te_fizz: Unable to find uid %d", atoi(teargs[0]));
              msgout(buff);
              return(0);
              }

sprite=PRECACHE_MODEL(teargs[1]);

     MESSAGE_BEGIN(MSG_PAS, SVC_TEMPENTITY, e->v.origin);
       WRITE_BYTE(effect);
       WRITE_SHORT(ENTINDEX(e));
       WRITE_SHORT(sprite);
       WRITE_BYTE(atoi(teargs[2]));
     MESSAGE_END();
     break;
  case 106: //te_model
     if (teargc<10)
        NOTENOUGHARGS("te_model (10)");
        
     a=atoi(teargs[0]);
     b=atoi(teargs[1]);
     c=atoi(teargs[2]);
     
     sprite = PRECACHE_MODEL(teargs[7]); // this is actually a model

     MESSAGE_BEGIN(MSG_PAS, SVC_TEMPENTITY, Vector(a,b,c));
       WRITE_BYTE(effect);
       WRITE_COORD(a);
       WRITE_COORD(b);
       WRITE_COORD(c);
       WRITE_COORD(atoi(teargs[3]));
       WRITE_COORD(atoi(teargs[4]));
       WRITE_COORD(atoi(teargs[5]));

       WRITE_ANGLE(atoi(teargs[6]));
       WRITE_SHORT(sprite); // this is actually a model
       WRITE_BYTE(atoi(teargs[8]));
       WRITE_BYTE(atoi(teargs[9]));
     MESSAGE_END();
     break;
  case 107: //te_explodemodel
     if (teargc<7)
        NOTENOUGHARGS("te_explodemodel (7)");
        
     a=atoi(teargs[0]);
     b=atoi(teargs[1]);
     c=atoi(teargs[2]);
     
     sprite = PRECACHE_MODEL(teargs[4]); // this is actually a model

     MESSAGE_BEGIN(MSG_PAS, SVC_TEMPENTITY, Vector(a,b,c));
       WRITE_BYTE(effect);
       WRITE_COORD(a);
       WRITE_COORD(b);
       WRITE_COORD(c);
       WRITE_COORD(atoi(teargs[3]));
       WRITE_SHORT(sprite); // this is actually a model
       WRITE_SHORT(atoi(teargs[5]));
       WRITE_BYTE(atoi(teargs[6]));
     MESSAGE_END();
     break;   
  case 108: //te_breakmodel
     if (teargc<14)
        NOTENOUGHARGS("te_model (14)");
        
     a=atoi(teargs[0]);
     b=atoi(teargs[1]);
     c=atoi(teargs[2]);
     
     sprite = PRECACHE_MODEL(teargs[10]); // this is actually a model

     MESSAGE_BEGIN(MSG_PAS, SVC_TEMPENTITY, Vector(a,b,c));
       WRITE_BYTE(effect);
       WRITE_COORD(a);
       WRITE_COORD(b);
       WRITE_COORD(c);
       WRITE_COORD(atoi(teargs[3]));
       WRITE_COORD(atoi(teargs[4]));
       WRITE_COORD(atoi(teargs[5]));

       WRITE_COORD(atoi(teargs[6]));
       WRITE_COORD(atoi(teargs[7]));
       WRITE_COORD(atoi(teargs[8]));

       WRITE_BYTE(atoi(teargs[9]));
       WRITE_SHORT(sprite); // this is actually a model
       WRITE_BYTE(atoi(teargs[11]));
       WRITE_BYTE(atoi(teargs[12]));
       WRITE_BYTE(atoi(teargs[13]));
     MESSAGE_END();
     break;
  case 110: //te_sprite_spray
     if (teargc<10)
        NOTENOUGHARGS("te_sprite_spray (10)");
        
     a=atoi(teargs[0]);
     b=atoi(teargs[1]);
     c=atoi(teargs[2]);
     
     sprite = PRECACHE_MODEL(teargs[6]); // this is actually a model

     MESSAGE_BEGIN(MSG_PAS, SVC_TEMPENTITY, Vector(a,b,c));
       WRITE_BYTE(effect);
       WRITE_COORD(a);
       WRITE_COORD(b);
       WRITE_COORD(c);
       WRITE_COORD(atoi(teargs[3]));
       WRITE_COORD(atoi(teargs[4]));
       WRITE_COORD(atoi(teargs[5]));

       WRITE_SHORT(sprite);
       WRITE_BYTE(atoi(teargs[7]));
       WRITE_BYTE(atoi(teargs[8]));
       WRITE_BYTE(atoi(teargs[9]));
     MESSAGE_END();
     break;
  case 111: //te_armor_ricochet
     if (teargc<4)
        NOTENOUGHARGS("te_armor_ricochet (4)");
        
     a=atoi(teargs[0]);
     b=atoi(teargs[1]);
     c=atoi(teargs[2]);

     MESSAGE_BEGIN(MSG_PAS, SVC_TEMPENTITY, Vector(a,b,c));
       WRITE_BYTE(effect);
       WRITE_COORD(a);
       WRITE_COORD(b);
       WRITE_COORD(c);
       WRITE_BYTE(atoi(teargs[3]));
     MESSAGE_END();
     break;
  case 113: // te_bubbles
     if (teargc<10)
        NOTENOUGHARGS("te_bubbles (10)");
        
     a=atoi(teargs[0]);
     b=atoi(teargs[1]);
     c=atoi(teargs[2]);

sprite=PRECACHE_MODEL(teargs[7]);
    
     MESSAGE_BEGIN(MSG_PAS, SVC_TEMPENTITY, Vector(a,b,c));
       WRITE_BYTE(effect);
       WRITE_COORD(a);
       WRITE_COORD(b);
       WRITE_COORD(c);
       
       WRITE_COORD(atoi(teargs[3]));
       WRITE_COORD(atoi(teargs[4]));
       WRITE_COORD(atoi(teargs[5]));

       WRITE_COORD(atoi(teargs[6]));
       WRITE_SHORT(sprite);
       WRITE_BYTE(atoi(teargs[8]));
       WRITE_COORD(atoi(teargs[9]));
     MESSAGE_END();
     break;
  case 114: // te_bubbletrail
     if (teargc<10)
        NOTENOUGHARGS("te_bubbletrail (10)");
        
     a=atoi(teargs[0]);
     b=atoi(teargs[1]);
     c=atoi(teargs[2]);

sprite=PRECACHE_MODEL(teargs[7]);
    
     MESSAGE_BEGIN(MSG_PAS, SVC_TEMPENTITY, Vector(a,b,c));
       WRITE_BYTE(effect);
       WRITE_COORD(a);
       WRITE_COORD(b);
       WRITE_COORD(c);
       
       WRITE_COORD(atoi(teargs[3]));
       WRITE_COORD(atoi(teargs[4]));
       WRITE_COORD(atoi(teargs[5]));

       WRITE_COORD(atoi(teargs[6]));
       WRITE_SHORT(sprite);
       WRITE_BYTE(atoi(teargs[8]));
       WRITE_COORD(atoi(teargs[9]));
     MESSAGE_END();
     break;
  case 115: // te_bloodsprite
     if (teargc<7)
        NOTENOUGHARGS("te_beamsprite (7)");
        
     a=atoi(teargs[0]);
     b=atoi(teargs[1]);
     c=atoi(teargs[2]);

sprite=PRECACHE_MODEL(teargs[3]);
sprite2=PRECACHE_MODEL(teargs[4]);
    
     MESSAGE_BEGIN(MSG_PAS, SVC_TEMPENTITY, Vector(a,b,c));
       WRITE_BYTE(effect);
       WRITE_COORD(a);
       WRITE_COORD(b);
       WRITE_COORD(c);
       WRITE_SHORT(sprite);
       WRITE_SHORT(sprite2);
       WRITE_BYTE(atoi(teargs[5]));
       WRITE_BYTE(atoi(teargs[6]));
     MESSAGE_END();
     break;
  case 119: // te_projectile
     if (teargc<9)
        NOTENOUGHARGS("te_projectile (9)");

            if ((e=FindPlayerByUID(atoi(teargs[8])))==NULL)
              {
              sprintf(buff, "te_projectile: Unable to find uid %d", atoi(teargs[0]));
              msgout(buff);
              return(0);
              }

     a=atoi(teargs[0]);
     b=atoi(teargs[1]);
     c=atoi(teargs[2]);

sprite=PRECACHE_MODEL(teargs[6]);
    
     MESSAGE_BEGIN(MSG_PAS, SVC_TEMPENTITY, Vector(a,b,c));
       WRITE_BYTE(effect);
       WRITE_COORD(a);
       WRITE_COORD(b);
       WRITE_COORD(c);
       WRITE_COORD(atoi(teargs[3]));
       WRITE_COORD(atoi(teargs[4]));
       WRITE_COORD(atoi(teargs[5]));

       WRITE_SHORT(sprite);

       WRITE_BYTE(atoi(teargs[7]));
       WRITE_BYTE((BYTE)ENTINDEX(e));
     MESSAGE_END();
     break;
  case 120: // te_spray
     if (teargc<11)
        NOTENOUGHARGS("te_spray (11)");

     a=atoi(teargs[0]);
     b=atoi(teargs[1]);
     c=atoi(teargs[2]);

sprite=PRECACHE_MODEL(teargs[6]);
    
     MESSAGE_BEGIN(MSG_PAS, SVC_TEMPENTITY, Vector(a,b,c));
       WRITE_BYTE(effect);
       WRITE_COORD(a);
       WRITE_COORD(b);
       WRITE_COORD(c);
       WRITE_COORD(atoi(teargs[3]));
       WRITE_COORD(atoi(teargs[4]));
       WRITE_COORD(atoi(teargs[5]));

       WRITE_SHORT(sprite);

       WRITE_BYTE(atoi(teargs[7]));
       WRITE_BYTE(atoi(teargs[8]));
       WRITE_BYTE(atoi(teargs[9]));
       WRITE_BYTE(atoi(teargs[10]));
     MESSAGE_END();
     break;
  case 122: // te_particleburst
     if (teargc<6)
        NOTENOUGHARGS("te_particleburst (6)");

     a=atoi(teargs[0]);
     b=atoi(teargs[1]);
     c=atoi(teargs[2]);

     MESSAGE_BEGIN(MSG_PAS, SVC_TEMPENTITY, Vector(a,b,c));
       WRITE_BYTE(effect);
       WRITE_COORD(a);
       WRITE_COORD(b);
       WRITE_COORD(c);
       WRITE_SHORT(atoi(teargs[3]));
       WRITE_BYTE(atoi(teargs[4]));
       WRITE_BYTE(atoi(teargs[5]));
     MESSAGE_END();
     break;
  case 123: // te_firefield
     if (teargc<8)
        NOTENOUGHARGS("te_spray (8)");

     a=atoi(teargs[0]);
     b=atoi(teargs[1]);
     c=atoi(teargs[2]);

sprite=PRECACHE_MODEL(teargs[4]);
    
     MESSAGE_BEGIN(MSG_PAS, SVC_TEMPENTITY, Vector(a,b,c));
       WRITE_BYTE(effect);
       WRITE_COORD(a);
       WRITE_COORD(b);
       WRITE_COORD(c);
       WRITE_SHORT(atoi(teargs[3]));
       WRITE_SHORT(sprite);

       WRITE_BYTE(atoi(teargs[5]));
       WRITE_BYTE(atoi(teargs[6]));
       WRITE_BYTE(atoi(teargs[7]));
     MESSAGE_END();
     break;
  case 124: // te_playerattachment
     if (teargc<4)
        NOTENOUGHARGS("te_playerattachment (4)");

            if ((e=FindPlayerByUID(atoi(teargs[0])))==NULL)
              {
              sprintf(buff, "te_playerattachment: Unable to find uid %d", atoi(teargs[0]));
              msgout(buff);
              return(0);
              }

sprite=PRECACHE_MODEL(teargs[2]);
    
     MESSAGE_BEGIN(MSG_PAS, SVC_TEMPENTITY, e->v.origin);
       WRITE_BYTE(effect);
       WRITE_BYTE((BYTE)ENTINDEX(e));
       WRITE_COORD(atoi(teargs[1]));
       WRITE_SHORT(sprite);
       WRITE_SHORT(atoi(teargs[3]));
     MESSAGE_END();
     break;
  case 125: //TE_killplayerattachments
     if (teargc<1)
        NOTENOUGHARGS("te_killplayerattachments (1)");

            if ((e=FindPlayerByUID(atoi(teargs[0])))==NULL)
              {
              sprintf(buff, "te_killplayerattach: Unable to find uid %d", atoi(teargs[0]));
              msgout(buff);
              return(0);
              }

     MESSAGE_BEGIN(MSG_PAS, SVC_TEMPENTITY, e->v.origin);
       WRITE_BYTE(effect); 
       WRITE_BYTE((BYTE)ENTINDEX(e));
     MESSAGE_END();
     break;
  case 127: // te_usertracer
     if (teargc<9)
        NOTENOUGHARGS("te_usertracer (9)");
        
     a=atoi(teargs[0]);
     b=atoi(teargs[1]);
     c=atoi(teargs[2]);
    
     MESSAGE_BEGIN(MSG_PAS, SVC_TEMPENTITY, Vector(a,b,c));
       WRITE_BYTE(effect);
       WRITE_COORD(a);
       WRITE_COORD(b);
       WRITE_COORD(c);
       
       WRITE_COORD(atoi(teargs[3]));
       WRITE_COORD(atoi(teargs[4]));
       WRITE_COORD(atoi(teargs[5]));

       WRITE_BYTE(atoi(teargs[6]));
       WRITE_BYTE(atoi(teargs[7]));
       WRITE_BYTE(atoi(teargs[8]));
     MESSAGE_END();
     break;
   default:
    snprintf(buff, sizeof(buff), "Unknown tempent: %d", effect);
    msgout(buff);
    break;
   } // end switch            

return(1);
}
else
       if (strcasecmp(gcmd, "sayhud")==0)
          {
           int u=atoi(opts);
           char parmstring[256];
           edict_t *targ;
           char *q;
           
            if (((p=strchr(opts, ' '))==NULL)||((q=strchr(p+1, ' '))==NULL)||(u<1)||((unsigned int)(a=q-p+1)>sizeof(parmstring)-1))
              {
              msgout("sayhud <uid> <options> <text>");
              return(0);
              }
       
       strncpy(parmstring, p+1, a);
       parmstring[a]=0;

            if ((targ=FindPlayerByUID(u))==NULL)
              {
              sprintf(buff, "Unable to find uid %d", u);
              msgout(buff);
              return(0);
              }

       hudtextparms_t tp;
       MakeHudParms(parmstring, tp);
       UTIL_MyHudMessage (targ, tp, q+1);
//       UTIL_LogPrintf("\"Hud:\" \"%s\" %s\n", STRING (targ->v.netname), q+1);
       return(1);
          }
else
      if (strcasecmp(gcmd, "particle")==0)
          {
           int u=atoi(opts);
           char parmstring[256];
           edict_t *targ;
           char *q;
           long v1,v2,v3;
           unsigned long clr,cnt;
           
            if (((p=strchr(opts, ' '))==NULL)||((unsigned int)(a=strlen(p))>sizeof(parmstring)-1))
              {
              msgout("particle <uid> <options>");
              return(0);
              }
       
       strncpy(parmstring, p+1, a);
       parmstring[a]=0;

            if ((targ=FindPlayerByUID(u))==NULL)
              {
              sprintf(buff, "Unable to find uid %d", u);
              msgout(buff);
              return(0);
              }
        p = parmstring;
        a=0;

while ( ((q=strchr(p, ','))!=NULL) || (p!=NULL))
  {
  a++;
  switch (a) 
    {
    case 1:
     clr=atoi(p);break;
    case 2:
     cnt=atoi(p);break;
    case 3:
     v1=atoi(p);break;
    case 4:
     v2=atoi(p);break;
    case 5:
     v3=atoi(p);break;
    }
  if ((q!=NULL)&&(*(q+1)!=0))
    p=q+1;
else
 break;
  }
    
          
        UTIL_ParticleEffect ( targ->v.origin, Vector( v1,v2,v3), clr, cnt);
        return(1);
       }
else
      if (strcasecmp(gcmd, "config")==0)
        {

         if ((p=strchr(opts, ' '))==NULL)
           {
           msgout("usage: config <variable> <value>");
           return(0);
           }
         
         *p=0;
         p++;
         
         if (strcasecmp(opts, "stripcmd")==0)
           stripcmd=atoi(p);
         else
         if (strcasecmp(opts, "elimdup")==0)
           elimdup=atoi(p);
         else
         if (strcasecmp(opts, "reportdelay")==0)
           reportdelay=atof(p);
         else
           {
           char errbuff[256];
           snprintf(errbuff, sizeof(errbuff)-1, "unknown config variable: %s", opts);
           msgout(errbuff);
           return(0);
           }        
        
        return(1);
        }
   UTIL_LogPrintf("Unknown command: \"%s\"\n", gcmd);
   return(0);
}

int CheckSock()
{

if (fsock==-1)
 return(0);
else


if (clisock==-1)
  {
  if ((clisock=accept(fsock, (struct sockaddr *) &fsockname, &fsocknamesize))!=-1)
   {
   UTIL_LogPrintf("Accepted connection\n");
   fcntl (clisock, F_SETFL, O_NONBLOCK);
   return(1);
   }   
  else
   {
if (!clierr)
   {
   UTIL_LogPrintf("Unable to establish connection: %s\n", strerror(errno));
   clierr=1;
   }
   return(0);
   }
   
  }
else    
  {  // check for data 
  char buff[1024], line[1024];
  int a,b;
  char *p;
            while ((a = read (clisock, line, sizeof (line) - 1)) > 0)
              {
                b = sizeof (inpbuff) - 1 - strlen (inpbuff);
                if (a < b)
                  b = a;
                strncat (inpbuff, line, b);
                while ((p = strchr (inpbuff, '\n')) != NULL)
                  {
                    strncpy (buff, inpbuff, p - inpbuff);
                    buff[p - inpbuff] = 0;
                    {
                       ProcessCommand(buff);
                    }
                    strcpy (buff, p + 1);
                    strcpy (inpbuff, buff);
                  }
              }                 /* end while read from server */
  
  }

return(0);
}

int 
MakeNamedSocket ()
{
  int sock;
  int a;
  struct stat *m;
  
  // Create the socket.
  
  sock = socket (PF_UNIX, SOCK_STREAM, 0);
  if (sock < 0)
    {
      perror ("socket");
      return(-1);
    }

// Find a filename

m = (struct stat *)malloc(sizeof (struct stat));

for (a=0;a<1000;a++)
  {  
  sprintf(fname, "goodies.%d.s", a);
  
  if (stat(fname, m))
    break;
  }

  if (!stat(fname, m))
   {
   free(m);
   msgout("Cannot find a file socket available (try rm -f goodies.*.s)");
   return(-1);
   }

free(m);

// Bind a name to the socket.

  fsockname.sun_family = AF_FILE;
  strcpy (fsockname.sun_path, fname);

  /* The size of the address is the offset of the start of the filename,
     plus its length, plus one for the terminating null byte. */

  fsocknamesize = (offsetof (struct sockaddr_un, sun_path) + strlen (fsockname.sun_path) + 1);

  if (bind (sock, (struct sockaddr *) &fsockname, fsocknamesize) < 0)
    {
      UTIL_LogPrintf("Goodies: Unable to bind file");
      perror ("bind"); return(-1);
    }

  return sock;
}

int GoodiesUnload () {
if (fsock!=-1)
  unlink(fname);

return(0);
}

int DestroyOurEnt(int a)
{
   free(ourent[a]);
if (numents-1)
   if (a!=numents-1)
     ourent[a]=ourent[numents-1];
   numents--;
return(0);
}
 
int msgout(char *msg)
{
if (clisock!=-11)
  {
  write(clisock, msg, strlen(msg));
  write(clisock, "\n", 1);
  return(1);
  }
else
 {
 UTIL_LogPrintf("\"Goodies:\" %s", msg);
 return(1);
 }
}

edict_t*
FindPlayerByUID(int uid)
{
edict_t *client;

   client = NULL;
    while ( ((client = UTIL_MyFindEntityByClassname( client, "player" )) != NULL) &&
       (!FNullEnt(client)) )
     {
     if (GETPLAYERUSERID( client )==uid)
       return(client);
     }

return(NULL);
}

int
MakeHudParms(char *string, hudtextparms_t &parms)
{
int a;
char *p, *q;

parms.x=0.1;  // setup some defaults
parms.y=0.3;
parms.effect=0;
parms.r1=parms.g1=parms.b1=255;
parms.r2=parms.g2=parms.b2=255;
parms.a1=255;parms.a2=255;
parms.fadeinTime=parms.fadeoutTime=0.5;
parms.holdTime=100;
parms.fxTime=0.2;
parms.channel=1;

p = string;
a=0;

while ( ((q=strchr(p, ','))!=NULL) || (p!=NULL))
  {
  a++;
  switch (a) 
    {
    case 1: //x
     parms.x=atof(p); break;
    case 2: //y
     parms.y=atof(p); break;
    case 3: //r1
     parms.r1=atoi(p); break;
    case 4: //g1
     parms.g1=atoi(p); break;
    case 5: //b1
     parms.b1=atoi(p); break;
    case 6: //a1
     parms.a1=atoi(p); break;
    case 7: //r2
     parms.r2=atoi(p); break;
    case 8: //g2
     parms.g2=atoi(p); break;
    case 9: //b2
     parms.b2=atoi(p); break;
    case 10: //a2
     parms.a2=atoi(p); break;
    case 11: //fadeinTime
     parms.fadeinTime=atof(p); break;
    case 12: //fadeoutTime
     parms.fadeoutTime=atof(p); break;
    case 13: //holdTime
     parms.holdTime=atof(p); break;
    case 14: //fxTime
     parms.fxTime=atof(p); break;
    case 15: //effect
     parms.effect=atoi(p); break;
    case 16: //channel
     parms.channel=atoi(p); break;
    default:
      break;
    }
  if ((q!=NULL)&&(*(q+1)!=0))
    p=q+1;
else
 break;
     
  }


//UTIL_LogPrintf("Hud message (%d): %0.2f %0.2f\n", a, parms.x, parms.y);

return(1);
}

int
GoodiesUpdateStatus()
{
   edict_t *stclient;
   char buff[512];
   int a;
   
   for (a=0;a<32;a++)
    if ( ((stclient=clients[a])!=NULL)&&(strlen(STRING(stclient->v.netname))) )
   {
                snprintf(buff, sizeof(buff), "Status: \"%s<%d>\" %.0f\"%.0f\"%.0f\"%.0f\"%.0f\"", STRING(stclient->v.netname), \
                GETPLAYERUSERID( stclient ), stclient->v.health, stclient->v.armorvalue, stclient->v.origin.x,stclient->v.origin.y,stclient->v.origin.z);
                msgout(buff);
   }
return(1);
}
edict_t *clients[32];


void GameDLLInit( void )
{
   int i;
   
   CVAR_REGISTER (&sv_goodies);

   for (i=0; i<32; i++)
      {
      clients[i] = NULL;
      clsay[i][0]=0;
      }

UTIL_LogPrintf("\"Goodies\" Version \"%s\" initialized.\n", GOODIESVERSION);

if ((fsock = MakeNamedSocket())== -1)
   {
   UTIL_LogPrintf("Unable to make Goodies Socket\n");
   }
  else
   { 
     chmod (fname, S_IRUSR|S_IWUSR);
     fcntl (fsock, F_SETFL, O_NONBLOCK);
     listen(fsock, 5);
     UTIL_LogPrintf("Goodies socket initialized \"%s\"\n", fname);
   }

bzero(inpbuff, sizeof(inpbuff));
RETURN_META(MRES_IGNORED);
}

int DispatchSpawn( edict_t *pent )
{
   if (gpGlobals->deathmatch)
   {
      char *pClassname = (char *)STRING(pent->v.classname);

      if (strcmp(pClassname, "worldspawn") == 0)
      {
       FILE *prec;
         // do level initialization stuff here...

PRECACHE_MODEL("sprites/laserbeam.spr");
PRECACHE_MODEL("sprites/zerogxplode.spr");

    if ((prec = fopen ("goodies.lst", "r")) != NULL)
    {
       char line1[1024];
       char *p;
       char* q;
       
      while (fgets (line1, 1024, prec) != NULL)
          {
        if ((p = strchr (line1, '\n')) != NULL)
           *p = 0;
       if ((p = strchr (line1, '\r')) != NULL)
          *p = 0;

    if (strlen(line1)<1)
     continue;
     q=(char *)malloc(strlen(line1)+1);
     strcpy(q, line1);
     
//         
        if (strstr(line1, ".wav")!=NULL)
         {(*g_engfuncs.pfnPrecacheSound)((char *)q);
//         UTIL_LogPrintf(line1);
         }
       else
        if ((strstr(line1, ".spr")!=NULL)||(strstr(line1, ".mdl")!=NULL))
         {PRECACHE_MODEL(q);}
        }
fclose(prec);    
    }

   } // end if worldspawn
  } //end if dm

RETURN_META_VALUE(MRES_IGNORED, 0);
}

BOOL ClientConnect( edict_t *pEntity, const char *pszName, const char *pszAddress, char szRejectReason[ 128 ]  )
{ 
   if (gpGlobals->deathmatch)
   {

      // check if this client is the listen server client
      if (strcmp(pszAddress, "loopback") == 0)
      {
         // save the edict of the listen server client...
         listenserver_edict = pEntity;
      }

   }
RETURN_META_VALUE(MRES_IGNORED, FALSE);
}

void ClientDisconnect( edict_t *pEntity )
{
   if (gpGlobals->deathmatch)
   {
      int i;

      i = 0;
      while ((i < 32) && (clients[i] != pEntity))
         i++;

      if (i < 32)
         clients[i] = NULL;
   }
RETURN_META(MRES_IGNORED);
}

void DispatchThink ( edict_t *pent ) {
int a;
for (a=0;a<numents;a++)
  if (pent==ourent[a]->ent)
    {
     pent->v.nextthink = gpGlobals->time + 0.5;
     
if (ourent[a]->life)
    { // see if this life is up
    ourent[a]->life -= gpGlobals->time-ourent[a]->lastthink;
    if (ourent[a]->life<=0)
      {
      REMOVE_ENTITY(ourent[a]->ent);
      DestroyOurEnt(a);
      RETURN_META(MRES_SUPERCEDE);
      }
    }
      
   ourent[a]->lastthink=gpGlobals->time;

switch (ourent[a]->behave)
   {
    case 0: // do nothing
      break;
    case 1: // find a object nearby and stare at it
      {
      edict_t *sent;
      edict_t *me=ourent[a]->ent;
      Vector tos;
      
      sent=UTIL_MyFindEntityInSphere( NULL, me->v.origin, 500.0);
      if (sent != NULL) 
      {
       tos = sent->v.origin - me->v.origin;
       ourent[a]->target=sent;
       me->v.angles = UTIL_VecToAngles(tos);
       me->v.angles.z=0;
       me->v.angles.x=0;
       pent->v.nextthink = gpGlobals->time + 0.1;
      }
           if (ourent[a]->activity != ACT_IDLE)
             UTIL_MySetActivity(me, ourent[a]->activity=ACT_IDLE);

      break;
      }
    case 2: // find a player nearby and stare at them
      {
      edict_t *sent;
      edict_t *me=ourent[a]->ent;
      Vector tos;
      
      sent=UTIL_FindPlayerVisInSphere( me, me->v.origin, 500.0);
      if (sent != NULL) 
      {
       tos = sent->v.origin - me->v.origin;
       me->v.angles = UTIL_VecToAngles(tos);
       me->v.angles.z=0;
       me->v.angles.x=0;
       pent->v.nextthink = gpGlobals->time + 0.1;
      }
           if (ourent[a]->activity != ACT_IDLE)
             UTIL_MySetActivity(me, ourent[a]->activity=ACT_IDLE);
      break;
      }
    case 3: // find a player nearby and walk towards them
      {
       edict_t *me=ourent[a]->ent;
       Vector tos;
       edict_t *sent;
       static Vector lastpos;

       switch (ourent[a]->state)
        {
         case 0: // find target
           if (ourent[a]->activity != ACT_IDLE)
             UTIL_MySetActivity(me, ourent[a]->activity=ACT_IDLE);
 
         if ((sent=UTIL_FindPlayerVisInSphere( me, me->v.origin, 1000.0))==NULL)
           break;
         ourent[a]->state=1;
         ourent[a]->target=sent;
         DROP_TO_FLOOR(me);
         tos = sent->v.origin - me->v.origin;
         me->v.angles = UTIL_VecToAngles(tos);
         me->v.angles.z=0;
         me->v.angles.x=0;
         pent->v.nextthink = gpGlobals->time + 0.1;
if (sent!=ourent[a]->lasttarget)
{
             char buff[256];
             snprintf(buff, sizeof(buff)-1, "target: \"%s\"%s<%d>", ourent[a]->name, STRING (sent->v.netname), GETPLAYERUSERID(sent));
             msgout(buff);
}
         break;
         case 1: // walk towards target;
         {
          int run=0;
       
          sent=ourent[a]->target;
          tos=sent->v.origin - me->v.origin;
          me->v.angles = UTIL_VecToAngles(tos);
          me->v.angles.z=me->v.angles.x=0;
          pent->v.nextthink = gpGlobals->time + 0.1;

          if ( (tos.Length()>1000)||(!UTIL_IsValidTarget(me, sent)) ) // give up
            {
             char buff[256];
             snprintf(buff, sizeof(buff)-1, "untarget: \"%s\"%s<%d>", ourent[a]->name, STRING( sent->v.netname) , GETPLAYERUSERID(sent));
             msgout(buff);
             ourent[a]->lasttarget=ourent[a]->target;
             ourent[a]->state=0;ourent[a]->target=NULL;
             if (ourent[a]->activity != ACT_IDLE)
             UTIL_MySetActivity(me, ourent[a]->activity=ACT_IDLE); 
             break;}
          if (tos.Length()<60)
           {
           if (ourent[a]->activity != ACT_IDLE)
             UTIL_MySetActivity(me, ourent[a]->activity=ACT_IDLE);
            break;   // wait here
           }

          if (tos.Length()>200)
          run=1;
        
          WALK_MOVE(me->v.pContainingEntity, VEC_TO_YAW(tos), run ? 19 : 6, 0);

if ((me->v.origin-lastpos).Length()<5)
  {
             if (ourent[a]->activity != ACT_IDLE)
             UTIL_MySetActivity(me, ourent[a]->activity=ACT_IDLE);
  } 
else
          if (run)
           {
            if (ourent[a]->activity != ACT_RUN)
            UTIL_MySetActivity(me, ourent[a]->activity=ACT_RUN);   
           }
          else
           if (ourent[a]->activity != ACT_WALK)
            UTIL_MySetActivity(me, ourent[a]->activity=ACT_WALK);

          break;
          }  // end of case 1
 
         default:
          break;
        } // end of switch(state)
      break; 
     } // end of case 3  
   default: 
     break;
   }
   // put in think switch here

   }
RETURN_META(MRES_IGNORED);   
}

void DispatchTouch( edict_t *pentTouched, edict_t *pentOther ) {
int a;

for (a=0;a<numents;a++)
  if (pentTouched==ourent[a]->ent)
   {
  char buff[256];

if (ourent[a]->touch&1)
  if ((GETPLAYERUSERID(pentOther)==-1)||(pentOther->v.deadflag != DEAD_NO))
  RETURN_META(MRES_IGNORED); // 1 ignores anything other than a live player touching it.

if (ourent[a]->touch&4)
  if ( (ourent[a]->target==NULL)||(pentOther!=ourent[a]->target) )
   RETURN_META(MRES_IGNORED);   
   

   snprintf(buff, sizeof(buff), "Touched \"%s<%d>\"%s", STRING(pentOther->v.netname), GETPLAYERUSERID ( pentOther ),
   ourent[a]->name);
   msgout(buff);

if (ourent[a]->touch&2) // 2 doesnt remove item after its touched
  RETURN_META(MRES_IGNORED);
     
   REMOVE_ENTITY(ourent[a]->ent);   
   DestroyOurEnt(a);
   RETURN_META(MRES_SUPERCEDE); // dont want them calling an entity that no longer exists.
   }

RETURN_META(MRES_IGNORED);
}


void StartFrame( void )
{
   if (gpGlobals->deathmatch)
   {

      // if a new map has started then (MUST BE FIRST IN StartFrame)...
      if ((gpGlobals->time + 0.1) < previous_time)
      {
         check_server_cmd = 0.0;  // reset at start of map
         info_time= 0.0;
         while (numents)
           DestroyOurEnt(0); // entity is already removed.
      }

       if (gpGlobals->time > info_time + reportdelay)
         {
         GoodiesUpdateStatus();
         info_time=gpGlobals->time;
         }

      // check for commands if needed
      if ((check_server_cmd <= gpGlobals->time) && IS_DEDICATED_SERVER())
      {
         check_server_cmd = gpGlobals->time + 0.1;

   //check to see if there is anytihng to do with the file socket 
         CheckSock();


/* 
         char *cvar_st = (char *)CVAR_GET_STRING( "goodies" );

         if ( cvar_st && cvar_st[0] )
         {
         ProcessCommand(cvar_st);
         CVAR_SET_STRING("goodies", "");
         }
*/
      }

      previous_time = gpGlobals->time;

//      if (previous_time < info_time)
//        info_time=previous_time;
   }

RETURN_META(MRES_IGNORED);
}

void ClientPutInServer( edict_t *pEntity )
{
   int i = 0;

   while ((i < 32) && (clients[i] != NULL))
      i++;

   if (i < 32)
      clients[i] = pEntity;  // store this clients edict in the clients array

RETURN_META(MRES_IGNORED);
}

void ClientCommand( edict_t *pEntity )
{
const char *pcmd=CMD_ARGV(0);

if (strcmp(pcmd, "say")==0)
  if (CMD_ARGC() >= 2)
   {
char buff[256];
char q[255];
char *p;
int a;
   strncpy(q, CMD_ARGS(), sizeof(q)-1);
   p=(char *)q;
   if ((p)&&(p[0]))
    {
    if (*p=='\"')
     {
      p[strlen(p)-1]=0;
      p++;
     }
    
    if (*p=='!')
     {
      snprintf(buff, sizeof(buff)-1, "Command \"%s<%d>\"%s", STRING(pEntity->v.netname), GETPLAYERUSERID(pEntity), p);
      msgout(buff);
      if (stripcmd)
       RETURN_META(MRES_SUPERCEDE);
     }

if (elimdup)
   for (a=0;a<32;a++)
    if (clients[a]==pEntity)
     {
     char *l=strchr(clsay[a], ',');
    if (l)
     if ( (strcasecmp(p, l+1)==0)&&(time(NULL)-atoi(clsay[a])<=elimdup) )
      {
      snprintf(buff, sizeof(buff)-1, "Duplicate line \"%s<%d>\"%s", STRING(pEntity->v.netname), GETPLAYERUSERID(pEntity), p);
      msgout(buff);
      RETURN_META(MRES_SUPERCEDE);
      }
     snprintf(clsay[a], sizeof(clsay[a])-1, "%d,%s", (int)time(NULL), p);
     break;
     }
    }
   }

RETURN_META(MRES_IGNORED);
}

static DLL_FUNCTIONS gFunctionTable = 
{
	GameDLLInit,					//! pfnGameInit()
	DispatchSpawn,					//! pfnSpawn()
	DispatchThink,					//! pfnThink()
	NULL,						//! pfnUse()
	DispatchTouch,					//! pfnTouch()
	NULL,						//! pfnBlocked()
	NULL,						//! pfnKeyValue()
	NULL,						//! pfnSave()
	NULL,						//! pfnRestore()
	NULL,						//! pfnSetAbsBox()

	NULL,						//! pfnSaveWriteFields()
	NULL,						//! pfnSaveReadFields()

	NULL,						//! pfnSaveGlobalState()
	NULL,						//! pfnRestoreGlobalState()
	NULL,						//! pfnResetGlobalState()

	ClientConnect,					//! pfnClientConnect()
	ClientDisconnect,				//! pfnClientDisconnect()
	NULL,						//! pfnClientKill()
	ClientPutInServer,				//! pfnClientPutInServer()
	ClientCommand,					//! pfnClientCommand()
	NULL,						//! pfnClientUserInfoChanged()
	NULL,						//! pfnServerActivate()
	NULL,						//! pfnServerDeactivate()

	NULL,						//! pfnPlayerPreThink()
	NULL,						//! pfnPlayerPostThink()

	StartFrame,					//! pfnStartFrame()
	NULL,						//! pfnParmsNewLevel()
	NULL,						//! pfnParmsChangeLevel()

	NULL,						//! pfnGetGameDescription()
	NULL,						//! pfnPlayerCustomization()

	NULL,						//! pfnSpectatorConnect()
	NULL,						//! pfnSpectatorDisconnect()
	NULL,						//! pfnSpectatorThink()
	
	NULL,						//! pfnSys_Error()

	NULL,						//! pfnPM_Move()
	NULL,						//! pfnPM_Init()
	NULL,						//! pfnPM_FindTextureType()
	
	NULL,						//! pfnSetupVisibility()
	NULL,						//! pfnUpdateClientData()
	NULL,						//! pfnAddToFullPack()
	NULL,						//! pfnCreateBaseline()
	NULL,						//! pfnRegisterEncoders()
	NULL,						//! pfnGetWeaponData()
	NULL,						//! pfnCmdStart()
	NULL,						//! pfnCmdEnd()
	NULL,						//! pfnConnectionlessPacket()
	NULL,						//! pfnGetHullBounds()
	NULL,						//! pfnCreateInstancedBaselines()
	NULL,						//! pfnInconsistentFile()
	NULL,						//! pfnAllowLagCompensation()
};

C_DLLEXPORT int GetEntityAPI2( DLL_FUNCTIONS *pFunctionTable, int *interfaceVersion )
{
        if(!pFunctionTable) {
                LOG_ERROR(PLID, "GetEntityAPI2 called with null pFunctionTable");
                return(FALSE);
        }
        else if(*interfaceVersion != INTERFACE_VERSION) {
                LOG_ERROR(PLID, "GetEntityAPI2 version mismatch; requested=%d ours=%d", *interfaceVersion, INTERFACE_VERSION);
                //! Tell engine what version we had, so it can figure out who is out of date.
                *interfaceVersion = INTERFACE_VERSION;
                return(FALSE);
        }
        memcpy( pFunctionTable, &gFunctionTable, sizeof( DLL_FUNCTIONS ) );
        return(TRUE);
}

int SetEnt (edict_t *targ,char *vn,char *val,int add, char *name)
{
int v1,v2,v3;
char *p, *q;

              if (strcasecmp(vn, "info")==0)
               {
                char buff[512];
                snprintf(buff, sizeof(buff), "Status: \"%s\" %.0f\"%.0f\"%.0f\"%.0f\"%.0f\"", name, targ->v.health, targ->v.armorvalue, targ->v.origin.x,targ->v.origin.y,targ->v.origin.z);
                msgout(buff);
                return(0);
               }

              v1=v2=v3=0;
              if ((p=strchr(val, ','))!=NULL)
                {
                v1=atoi(val);
                v2=atoi(p+1);
                if ((q=strchr(p+1, ','))!=NULL)
                  v3=atoi(q+1);
                }

              if (strcasecmp(vn, "model")==0)
                   {
                   if (strcasecmp(val, "show")==0)
                    UTIL_LogPrintf("%s model: %s\n", STRING( targ->v.netname ), STRING( targ->v.model ));
                   else
                    {
//                    targ->v.model = MAKE_STRING( vn );
//                    SET_MODEL( targ, val);
		    (*g_engfuncs.pfnSetModel)(targ, val);
                    }
                   return(0);
                   }
if (strcasecmp(vn, "size")==0)
{
           char args[25][64];
           int argc=0;
            char *p, *q;
            int w1,w2,w3;
          
           q=(char *)val;
           
while ((p=(char *)strtok(q, ","))!=NULL)
 {
 strncpy(args[argc], p,sizeof(args[argc])); 
 argc++;q=NULL;
}

if (argc<6)
  {
  msgout("Usage: size <xmin> <ymin> <zmin> <xmax> <ymax> <xmax>");
  return(0);
  }

v1=atoi(args[0]);
v2=atoi(args[1]);
v3=atoi(args[2]);
w1=atoi(args[3]);
w2=atoi(args[4]);
w3=atoi(args[5]);

SET_SIZE( targ, Vector(v1,v2,v3), Vector(w1,w2,w3));
return(1);
}
              if (strcasecmp(vn, "scale")==0)
                   {
                   float sc=atof(val);
                   
                   if (sc<0)
                     sc=0;
                   else
                    if (sc>255)
                      sc=255;  

                    targ->v.scale = sc;

                   return(0);
                   }
              if (strcasecmp(vn, "solid")==0)
                   {
                    targ->v.solid = atoi(val);
                   return(0);
                   }
              if (strcasecmp(vn, "gravity")==0)
                   {
                    targ->v.gravity = atof(val);
                   return(0);
                   }
              if (strcasecmp(vn, "light")==0)
                   {
                    targ->v.light_level = atoi(val);
                   return(0);
                   }

              if (strcasecmp(vn, "health")==0)
                   {
                   float hl=atof(val);
                                        
                   if ((targ->v.health<1)||(targ->v.deadflag!=DEAD_NO))
                    return(0);

                   if (add)
                     hl+=targ->v.health;

                   if (hl<1)
                     hl=1;
                     
                  if (hl<targ->v.health)
                   (*g_engfuncs.pfnEmitSound)( targ, CHAN_VOICE, "player/pain2.wav", 1.0, ATTN_NORM, 0, PITCH_NORM);
                  else
                   (*g_engfuncs.pfnEmitSound)( targ, CHAN_VOICE, "items/smallmedkit1.wav", 1.0, ATTN_NORM, 0, PITCH_NORM);

                  targ->v.health=hl;
                
                return(0);
               }          
              if (strcasecmp(vn, "armor")==0)
                   {
                   float al=atof(val);
                   
                   if (targ->v.armorvalue<1)
                    return(0);
                   
                   if (add)
                     al+=targ->v.armorvalue;
                   
                   if (al<0)
                     al=0;
                     
//                  if (hl<targ->v.armorvalue)
//                   (*g_engfuncs.pfnEmitSound)( targ, CHAN_VOICE, "player/pl_pain2.wav", 1.0, ATTN_NORM, 0, PITCH_NORM);
//                  else
//                   (*g_engfuncs.pfnEmitSound)( targ, CHAN_VOICE, "items/smallmedkit1.wav", 1.0, ATTN_NORM, 0, PITCH_NORM);

                  targ->v.armorvalue=al;

                return(0);
               }          
         else
              if (strcasecmp(vn, "effect")==0)
                 {
                 targ->v.effects=atoi(val);
                 return(0);
                 }
         else
              if (strcasecmp(vn, "rendercolor")==0)
              {
              targ->v.rendercolor=Vector(v1,v2,v3);
              return(0);
              }
         else
              if (strcasecmp(vn, "punchangle")==0)
              {
              targ->v.punchangle=Vector(v1,v2,v3);
              return(0);
              }
else
              if (strcasecmp(vn, "rendermode")==0)
                 {
                 if ((p=strchr(val, ','))!=NULL)
                  targ->v.renderamt=atoi(p+1);
                 switch (atoi(val)) { 
                   case 0:
                    targ->v.rendermode=kRenderNormal;
                    break;
                   case 1:
                    targ->v.rendermode=kRenderTransColor;
                    break;
                   case 2:
                    targ->v.rendermode=kRenderTransTexture;
                    break;
                   case 3:
                    targ->v.rendermode=kRenderGlow;
                    break;
                   case 4:
                    targ->v.rendermode=kRenderTransAlpha;
                    break;
                   case 5:
                    targ->v.rendermode=kRenderTransAdd;
                    break;
                    }
                    return(0);
            }
           else
              if (strcasecmp(vn, "renderfx")==0)
                 {
                 if ((p=strchr(val, ','))!=NULL)
                  targ->v.renderamt=atoi(p+1);

                 switch (atoi(val)) { 
                   case 0:
                     targ->v.renderfx=0;
                     break;
                   case 1:
                     targ->v.renderfx= kRenderFxHologram;
                     break;
                   case 2:
                     targ->v.renderfx= kRenderFxDistort;
                     break;
                  case 3:
                     targ->v.renderfx= kRenderFxGlowShell;
                     break;
                  case 4:
                     targ->v.renderfx= kRenderFxExplode;
                     break;
                  case 5:
                     targ->v.renderfx= kRenderFxFlickerSlow;
                     break;
                   }
                 return(0);
                 }
else
 if (strcasecmp(vn, "maxspeed")==0)
      {
     if (GETPLAYERUSERID( targ) != -1)
 {
       (*g_engfuncs.pfnSetClientMaxspeed)(targ, atof(val));
       return(0);
}
 else
    {
    msgout("target for maxspeed is not a player!");
    return(0);
    }
    
      }

          UTIL_LogPrintf("Unknown set variable: %s\n", vn);
return(0);
}
