#ifndef ENGINECALLBACK_H
#include "enginecallback.h"
#endif

#include "cbase.h"
#include "entity_state.h"

extern edict_t	*UTIL_MyFindEntityByClassname(edict_t *pStartEntity, const char *szName );
extern edict_t	*UTIL_MyFindEntityByString(edict_t *pStartEntity, const char *szKeyword, const char *szValue );

extern void			UTIL_ParticleEffect		( const Vector &vecOrigin, const Vector &vecDirection, ULONG ulColor, ULONG ulCount );
//extern void			UTIL_ScreenShake		( const Vector &center, float amplitude, float frequency, float duration, float radius );
//extern void			UTIL_ScreenShakeAll		( const Vector &center, float amplitude, float frequency, float duration );
//extern void			UTIL_ShowMessage		( const char *pString, CBaseEntity *pPlayer );
//extern void			UTIL_ShowMessageAll		( const char *pString );
//extern void			UTIL_ScreenFadeAll		( const Vector &color, float fadeTime, float holdTime, int alpha, int flags );
//extern void			UTIL_ScreenFade			( CBaseEntity *pEntity, const Vector &color, float fadeTime, float fadeHold, int alpha, int flags );

extern void			UTIL_ClientPrintAll( int msg_dest, const char *msg_name, const char *param1 = NULL, const char *param2 = NULL, const char *param3 = NULL, const char *param4 = NULL );

extern void			UTIL_SayText( const char *pText, CBaseEntity *pEntity );
extern void			UTIL_SayTextAll( const char *pText, CBaseEntity *pEntity );

extern void			UTIL_FakeMsg( int color, char *message );
extern void			UTIL_FakeMsgOne( int color, char *message, edict_t *targ );

void pfnMessageBegin( int msg_dest, int msg_type, const float *pOrigin, edict_t *ed );
void pfnMessageEnd( void );
void pfnWriteByte( int iValue );
void pfnWriteChar( int iValue );
void pfnWriteShort( int iValue );
void pfnWriteLong( int iValue );
void pfnWriteAngle( float flValue );
void pfnWriteCoord( float flValue );
void pfnWriteString( const char *sz );
void pfnWriteEntity( int iValue );

//static short FixedSigned16( float value, float scale );
//static unsigned short FixedUnsigned16( float value, float scale );

// prints as transparent 'title' to the HUD
extern void			UTIL_HudMessageAll( const hudtextparms_t &textparms, const char *pMessage );
extern void			UTIL_MyHudMessage( edict_t *client, const hudtextparms_t &textparms, const char *pMessage );

extern void			UTIL_EmitAmbientSound	( edict_t *entity, const Vector &vecOrigin, const char *samp, float vol, float attenuation, int fFlags, int pitch );
extern edict_t *UTIL_MyFindEntityInSphere( edict_t *pentStart, const Vector &vecCenter, float flRadius);
extern edict_t *UTIL_FindPlayerVisInSphere( edict_t *pentStart, const Vector &vecCenter, float flRadius );
extern int UTIL_MySetActivity (edict_t *targ, Activity newact);
extern int UTIL_LookupActivity( void *pmodel, entvars_t *pev, int activity );
extern int UTIL_IsValidTarget(edict_t *pentMe, edict_t *pentTarg);

